# Modulo: funciones para volar drone
import socket
import time
import sys
import re

# Crea canal UDP
localhost = ''
localport = 9000
localaddr = (localhost, localport)

dronehost = '192.168.10.1'
droneport = 8889
droneaddr = (dronehost, droneport)
 
canal = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
canal.bind(localaddr)

def enviarecibe(comando, pausa=2):
	try:
		# Envia mensaje
		if "?" in comando:
			pausa = 0.001
		mensaje = comando.encode(encoding="utf-8")	
		sent = canal.sendto(mensaje, droneaddr)
		time.sleep(pausa)
		
		# Recibe mensaje
		respuesta, ip = canal.recvfrom(1024)
		respuesta = respuesta.decode(encoding="utf-8")
		return respuesta
		
	except socket.error:
		print("Error: " + socket.error)
		exit()

def mueve(direccion, distancia):
	mensaje = direccion + " " + str(distancia)
	respuesta = enviarecibe(mensaje)
	return respuesta
	
def lee_tof():
	respuesta = enviarecibe("tof?")
	arrayTof = re.findall("\d+", respuesta)
	intTof = int(arrayTof[0])
	return intTof
