import socket
import datetime as dt
import time
import sys
import re

# Crea canal UDP
localhost = ''
localport = 9000
localaddr = (localhost, localport)

dronehost = '192.168.10.1'
droneport = 8889
droneaddr = (dronehost, droneport)
 
canal = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
canal.bind(localaddr)

def enviarecibe(comando, pausa=2):
	try:
		# Envia mensaje
		if "?" in comando:
			pausa = 0.001
		mensaje = comando.encode(encoding="utf-8")	
		sent = canal.sendto(mensaje, droneaddr)
		time.sleep(pausa)
		
		# Recibe mensaje
		respuesta, ip = canal.recvfrom(1024)
		respuesta = respuesta.decode(encoding="utf-8")
		print(str(dt.datetime.now()) + " " + comando + " " + str(ip) + " " + respuesta)
		return respuesta
		
	except socket.error:
		print("Error: " + socket.error)
		exit()

def explora(distancia):
	mensaje = "forward " + str(distancia)
	respuesta = enviarecibe(mensaje)
	return respuesta
	
def get_tof()
	respuesta = enviarecibe("tof?")
	arrayTof = re.findall("\d+", respuesta)
	intTof = int(arrayTof[0])
	return intTof

# Parametros
mesa = 40; ancho = 90; largo = 120
D = int(mesa / 2); A = int(ancho / D); L = int(largo / D)
print("D=" + str(D) + ", A=" + str(A) + ", L=" + str(L))

# Inicia la mision
enviarecibe("command", 7)
enviarecibe("takeoff", 5)
enviarecibe("up 50")
enviarecibe("tof?")
angulo = True

# Sobrevuela el terreno
for i in range(A):
        for j in range(L):
                print ("i=" + str(i) + ", j=" + str(j))
                explora(D)

        if (angulo == True):
                giro = "cw 90"
        else:
                giro = "ccw 90"
		
        enviarecibe(giro)
        explora(D)
        enviarecibe(giro)
	
        angulo = not angulo
        enviarecibe("tof?")

print ("finalizando...")	
canal.close()
