import socket
import datetime as dt
import time
import sys

# Crea canal UDP
localhost = ''
localport = 9000
localaddr = (localhost, localport)

dronehost = '192.168.10.1'
droneport = 8889
droneaddr = (dronehost, droneport)
 
canal = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
canal.bind(localaddr)

def enviarecibe(mensaje, pausa=2):
	try:
		# Envia mensaje
		if "?" in mensaje:
			pausa = 0.001
		print(str(dt.datetime.now()) + " pausa: " + str(pausa))		
		mensaje = mensaje.encode(encoding="utf-8")	
		sent = canal.sendto(mensaje, droneaddr)
		time.sleep(pausa)
		
		# Recibe mensaje
		mensaje, ip = canal.recvfrom(1024)
		respuesta = mensaje.decode(encoding="utf-8")
		print(str(dt.datetime.now()) + " " + str(ip) + " " + respuesta)
		return respuesta
		
	except socket.error:
		print("Error: " + socket.error)
		exit()

# Procesar comandos
enviarecibe("command", 7)

plandevuelo = sys.argv[1]
pv = open(plandevuelo, 'rt')

while True:
	
	comando = pv.readline().rstrip()
	print (comando)

	if (comando == ""):
		break 

	if (comando == "end"):
		break
		
	enviarecibe(comando)

print ("finalizando...")	
canal.close()
