import socket
import time

# Crea canal UDP
localhost = ''
localport = 9000
localaddr = (localhost, localport)

dronehost = '192.168.10.1'
droneport = 8889
droneaddr = (dronehost, droneport)
 
canal = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
canal.bind(localaddr)

# Enviar packet UDP al drone
def envia(mensaje):
	mensaje = mensaje.encode(encoding="utf-8") 
	sent = canal.sendto(mensaje, droneaddr)
	time.sleep(5)

# Transformar nodo a comando
def nodoacomando(nodo):
	dicletracmd = {"E":"takeoff", "S":"up", "A":"forward",
			"R":"back", "F":"land"}
	letra = nodo[0:1]
	dronecmd = dicletracmd[letra]
	p = int(nodo[1:2]) * 10 + int(nodo[2:3])
	if (p > 0):
		dronecmd = dronecmd + " " + str(p)
	return dronecmd

# Procesar comandos
envia("command")
cmd = ["E00","S50","A50","R50","F00"]
for ck in cmd: 	
	comando = nodoacomando(ck)
	print (comando)

	if (comando == ""):
		print ("comando invalido...")
		continue  

	if (comando == "end"):
		break
		
	envia(comando)

print ("finalizando...")	
canal.close()
