import socket
import datetime as dt
import time
import sys
import re

class Drone:
        LOCAL_PORT = 9000
        DRONE_IP = '192.168.10.1'
        DRONE_PORT = 8889

        def __init__(self, drone_ip=DRONE_IP):
                self.drone_ip = drone_ip
                global canal
                canal = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
                canal.bind(("", Drone.LOCAL_PORT))
                print("objeto creado: " + drone_ip)
                
        def enviarecibe(self, comando, pausa=2):
                try:
                        # Envia mensaje
                        if "?" in comando:
                                pausa = 0.001
                        mensaje = comando.encode(encoding="utf-8")
                        sent = canal.sendto(mensaje, (self.drone_ip, Drone.DRONE_PORT))
                        time.sleep(pausa)

                        # Recibe mensaje
                        respuesta, ip = canal.recvfrom(1024)
                        respuesta = respuesta.decode(encoding="utf-8")
                        print(str(dt.datetime.now()) + ", pausa=" + str(pausa) +
                              ", " + comando + ", " + str(ip) + ", " + respuesta)
                        return respuesta

                except socket.error:
                        print("Error: " + socket.error)
                        exit()

        def mueve(self, direccion, distancia):
                mensaje = direccion + " " + str(distancia)
                respuesta = self.enviarecibe(mensaje)
                return respuesta

        def lee_tof(self):
                respuesta = self.enviarecibe("tof?")
                arrayTof = re.findall("\d+", respuesta)
                intTof = int(arrayTof[0])
                return intTof
